#!/bin/sh

# commands
LN="/bin/ln -sf"
CP="/bin/cp -fa"
RM="/bin/rm"

SND=/dev/snd

# APP DIR
SZP_SOUNDSGOOD_DIR=/usr/local/AppCentral/soundsgood

# CGI 
SZ_CGI_MEDIA=media.cgi
SZ_CGI_LOCALPLAYER=localplayer.cgi

# executable files
SZ_SOUNDSGOODD_NAME=soundsgoodd
SZ_AS_PLAYERD_NAME=as_playerd
SZP_SOUNDSGOODD=/usr/local/AppCentral/soundsgood/bin/soundsgoodd
SZP_AS_PLAYERD=/usr/local/AppCentral/soundsgood/bin/as_playerd

# pid file
SOUNDSGOOD_PID=/var/run/soundsgood.pid
SOUNDSGOOD_PLAYER_PID=/var/run/as_playerd.pid

case $1 in

	start)
		echo "start SoundsGood...."
		
		# for device
		if [ ! -e $SND ]; then
			/bin/mkdir $SND
	  	fi
		
		# lib check
		$SZP_SOUNDSGOOD_DIR/CONTROL/check-lib.sh
       	
		# for daemons
		$SZP_SOUNDSGOODD > /dev/null 2>&1 &
		$SZP_AS_PLAYERD > /dev/null 2>&1 &
		
		# for alsa plugin
		$CP $SZP_SOUNDSGOOD_DIR/lib/alsa-lib/*.so* /usr/builtin/lib/alsa-lib/

		# package for python 
		if [ "" == "`/usr/local/bin/pip list | grep XlsxWriter`" ]; then
			/usr/local/bin/pip install XlsxWriter
		fi
		if [ "" == "`/usr/local/bin/pip list | grep xlwt`" ]; then
			/usr/local/bin/pip install xlwt
		fi
		if [ "" == "`/usr/local/bin/pip list | grep html5lib`" ]; then
			/usr/local/bin/pip install --upgrade setuptools
			/usr/local/bin/pip install html5lib
		fi
		if [ "" == "`/usr/local/bin/pip list | grep beautifulsoup4`" ]; then
			/usr/local/bin/pip install beautifulsoup4
		fi

		# register service 
		/usr/builtin/sbin/avahiregister -reg soundsgood %h _ASUSTOR_SOUNDSGOOD._tcp -1
		;;

	stop)
		echo "stop SoundsGood...."
		# daemon, CGI
		killall -SIGTERM $SZ_SOUNDSGOODD_NAME
		killall -SIGTERM $SZ_AS_PLAYERD_NAME
		killall -SIGTERM $SZ_CGI_MEDIA
		killall -SIGTERM $SZ_CGI_LOCALPLAYER
		sleep 1
		killall -SIGKILL $SZ_SOUNDSGOODD_NAME
		killall -SIGKILL $SZ_AS_PLAYERD_NAME
		killall -SIGKILL $SZ_CGI_MEDIA
		killall -SIGKILL $SZ_CGI_LOCALPLAYER
		
		# remove pid file
		/bin/rm $SOUNDSGOOD_PID
		/bin/rm $SOUNDSGOOD_PLAYER_PID

		# remove tmp files
		/bin/rm -rf $SZP_SOUNDSGOOD_DIR/tmp/*

		# un-register service
		/usr/builtin/sbin/avahiregister -unreg soundsgood
		;;

	*)
		echo "usage: $0 {start|stop}"
		exit 1
		;;
esac
exit 0
