import sqlite3
import sys
import xlwt
import xlsxwriter
import time 

EVENTLOG="/usr/local/AppCentral/soundsgood/var/log.db"
DB_COL = ['type', 'log_time', 'owner', 'description']

def event_type_matched_string(idxevent):
    ''' find the string that matched the event type '''
    if 1 == idxevent:
        return "INFO"
    elif 2 == idxevent:
        return "ERROR"
    else:
        return "UNKNOWN"


def fetch_logs(user, event_type):
    ''' fetch logs and store it '''
    try:
        db = sqlite3.connect(EVENTLOG)
        if 0 == len(user) :
            items = db.execute("SELECT type, log_time, owner, description FROM events WHERE type & " + event_type)
        else :
            items = db.execute("SELECT type, log_time, owner, description FROM events WHERE owner=\"" + user + "\" AND type & " + event_type)
        return items
    except :
        print sys.exc_info()
        return None

def convert_log_to_excel(logs, doctype, store_path):
    ''' convert logs to execel file '''
    if 'xls' == doctype:
        # open xls 
        xlsfile = xlwt.Workbook()
        # add a sheet
        xlssheet = xlsfile.add_sheet('logs')
        # writing col
        for name in range(0, len(DB_COL)):
            xlssheet.write(0, name, DB_COL[name])
        # writing data
        index = 1
        for item in logs:
            for col in range(0, len(item)):
                if 0 == col:
                    xlssheet.write(index, col, event_type_matched_string(item[col]))
                elif 1 == col:
                    szDate = time.strftime("%Y/%m/%d %p %I:%M:%S", time.localtime(item[col]));
                    xlssheet.write(index, col, szDate)
                else:
                    xlssheet.write(index, col, item[col])
            index += 1
        # close
        xlsfile.save(store_path)
        pass
    elif 'xlsx' == doctype:
        # open xlsx
        xlsxfile = xlsxwriter.Workbook(store_path)
        xlsxsheet = xlsxfile.add_worksheet()
        # writing col
        for name in range(0, len(DB_COL)):
            xlsxsheet.write(0, name, DB_COL[name])
        # writing data
        index = 1
        for item in logs:
            for col in range(0, len(item)):
                if 0 == col:
                    xlsxsheet.write(index, col, event_type_matched_string(item[col]))
                elif 1 == col:
                    szDate = time.strftime("%Y/%m/%d %p %I:%M:%S", time.localtime(item[col]));
                    xlsxsheet.write(index, col, szDate)
                else:
                    xlsxsheet.write(index, col, item[col])
            index += 1
        # close
        xlsxfile.close()
    else:
        pass

def usage():
    print "Usage:"
    print "{file} [owner] [event_type] [doctype (xls | xlsx)] [store_file_path]".format(file=__file__)

if __name__ == '__main__':
    if 4 > len(sys.argv):
        usage()
        sys.exit()
    # fetch logs
    logs = fetch_logs(sys.argv[1], sys.argv[2])
    # convert it
    convert_log_to_excel(logs, sys.argv[3], sys.argv[4])
